#pragma once

#include <stdint.h>
#include <stdbool.h>
#include "defs.h"

/* Configuration struct for gdb_init() */
typedef struct {
    /* Map core to TTY channel. The value -1 will disable debugging for that core */
    int tty_channel[NUM_CORES];
    /* Pointer to a kill function. This function is invoked by the stub when to kill the target program */
    void (*kill_program_handler) (void);
} gdb_config_t;

/* Initializes the GDB stub. Should only be called by a single core. */
void gdb_init(gdb_config_t * config);


#ifndef DISABLE_DEBUGGER
#define GDB_TRAP __asm__ __volatile__ ("mcr p1, 6, R13, c9, c4, 1\n\t")
#else
#define GDB_TRAP while(0)
#endif 
