#include <stdlib.h>
#include <stdio.h>
#include <stdbool.h>
#include <stdint.h>
#include <assert.h>
#include <errno.h>


#include "gdb.h"
#include "test-misc.h"
#include "tests.h"

#define ENOMEM          12      /* Out of memory */
char prog_top;    /* Defined by the linker.  */

void irq_c_handler(void)
{
    return;
}

void undef_instr_c_handler(void)
{
    return;
}

void die(void)
{
    put_string(0, "Killed\n");
    return;
}

int main(void)
{    
    gdb_config_t gdb_config;
    gdb_config.tty_channel[0] = 1;
    gdb_config.tty_channel[1] = -1;
    gdb_config.tty_channel[2] = -1;
    gdb_config.kill_program_handler = &die;
    gdb_init(&gdb_config);
    // GDB_TRAP;
    run_tests();
    GDB_TRAP;
    return 0;
}

caddr_t _sbrk(int incr)
{
    register char *stack_ptr __asm__("sp");

    static char *heap_end = NULL;
    char *prev_heap_end = NULL;

    if (heap_end == NULL)
        heap_end = &prog_top;

    prev_heap_end = heap_end;

    //printf("0x%08x + %d >= 0x%08x ? ", heap_end, incr, stack_ptr);
    if (heap_end + incr >= stack_ptr) {
        //printf("yes\r\n");
        errno = ENOMEM;
        return (caddr_t) - 1;
    }
    //printf("no\r\n");

    heap_end += incr;

    return (caddr_t) (incr > 0 ? prev_heap_end : heap_end);
}
