#include <inttypes.h>
#include <stdio.h>
#include "shmac.h"
#include "test-misc.h"

void put_char(int channel, uint8_t c)
{
    volatile uint32_t *sys_out_data = (volatile uint32_t *)((uint32_t)SYS_OUT_DATA_0 | ((channel & 0xf) << 4));
    // wait
    while((*SYS_INT_STATUS) & (1 << channel));
    // write word
    *sys_out_data = c;
}

void put_string(int channel, char * s)
{
    while(*s != 0)
    {
        if(*s == '\n') put_char(channel, '\r');
        put_char(channel, *s);
        s++;
    }
}

bool assert_equals(uint32_t expected, uint32_t actual, char * name)
{
    char buffer[1024];
    bool success;
    if (expected == actual)
    {
        snprintf(buffer, 1024, "PASSED! - %s\n", name);
        success = true;
    } else
    {
        snprintf(buffer, 1024, "FAILED! - %s - %"PRIu32" != %"PRIu32"\n", name, expected, actual);
        success = false;
    }
    put_string(0, buffer);
    return success;
}