#pragma once
#include "gdb/enable.h"

#include <stdint.h>
#include <stdbool.h>
#include "gdb/defs.h"


#ifndef DISABLE_DEBUGGER
#define GDB_TRAP __asm__ __volatile__ ("mcr p1, 6, R13, c9, c4, 1\n\t")
#else
#define GDB_TRAP while(0)
#endif 

typedef struct {
    int tty_channel[NUM_CORES];
    void (*kill_program_handler) (void);
} gdb_config_t;

void gdb_init(gdb_config_t * config);

// Returns true when the exception should be forwarded to user handler
bool gdb_exception_handler(uint32_t * registers);

void gdb_print(char *buffer);

// Returns true when the exception should be forwarded to user handler
bool gdb_c_irq_handler(uint32_t *pc, uint32_t spsr);