#pragma once

#include "gdb/enable.h"

#include <barrelfish_kpi/dispatcher_handle.h>
#include <errors/errno.h>
#include <stdbool.h>
#include <stdint.h>

#define MAX_PROCESS_ENTRIES 64

void gdb_process_init(void);
void gdb_on_core_setup(uint32_t core_id, uint32_t text_segment);
void gdb_on_process_created(dispatcher_handle_t handle, uint32_t segment_address);
void gdb_on_process_destroyed(dispatcher_handle_t handle);
void attach_process(uint32_t pid);
bool is_library_xml_updated(void);
uint32_t get_current_pid(void);
void write_library_list(char * output, uint32_t offset, uint32_t length);
void write_core_reloc(char * output);
void print_processes(void);
